//+------------------------------------------------------------------+
//|                                     Directional Volume Index.mq4 |
//|                             Ported to MT4 in 2023 by Julien Moog |
//|                                         http://www.qchartist.net |
//+------------------------------------------------------------------+
// @version=4
// Copyright: Please reference to the URL of this script if you are copying any part(s) for your own script.
// The novel aspects and principles of this indicator and this source code are the property of (c) cybernetwork.
#property copyright "Programmed by Julien Moog in 2023"
#property link      "http://www.qchartist.net"
#property version   "1.00"
//#property strict
#property indicator_separate_window
//#property indicator_minimum -0.5
//#property indicator_maximum 0.5
#property indicator_buffers 1
#property indicator_plots   1
//--- plot Buffer1
#property indicator_label1  "Buffer1"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrGold
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1

#property indicator_level1     0
#property indicator_levelcolor clrSilver
#property indicator_levelstyle STYLE_SOLID

//--- input parameters
input int      Period=50;
//--- indicator buffers
double Directional_Volume_Indexbuffer[1000];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorDigits(Digits);
   //---- indicators
   SetIndexDrawBegin(0,999);
   
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(0,Directional_Volume_Indexbuffer);
   //---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Directional Volume Index");
   SetIndexLabel(0,"DVI");
   
   
   //----
   return(0);
  }
  //+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   //---- 
   
   //----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
//---
int intperiod=999;
int intcurtf=0;
int p;
double buffersma1[1000];
double buffersma2[1000];
double buffersmarelative[1000];
double buffersma3[1000];
double dvi[1000];
double buffersma1b[1000];
double buffersma2b[1000];
double sum;
int i;

      // SMA1      
p=intperiod;
int intperiod2=50;
int ma_shift=0;
int ma_method=0;
    int per;
    sum=0;    
    if (p<intperiod2) p=intperiod2;
    per=intperiod2;
int applied_price=5; //PRICE_TYPICAL
int timeframe=0;

    for (i=1;i<=per-1;i++) {
        sum=sum+((iHigh(0,timeframe,p)+iLow(0,timeframe,p)+iClose(0,timeframe,p))/3)*iVolume(0,timeframe,p);
        p--;
                           }
    while (p>=0) {
        sum=sum+((iHigh(0,timeframe,p)+iLow(0,timeframe,p)+iClose(0,timeframe,p))/3)*iVolume(0,timeframe,p);        
		buffersma1[p]=sum/per;
        sum=sum-((iHigh(0,timeframe,p+per-1)+iLow(0,timeframe,p+per-1)+iClose(0,timeframe,p+per-1))/3)*iVolume(0,timeframe,p+per-1);
        p--;
                 }

 // SMA2      
p=intperiod;
intperiod2=50;
ma_shift=0;
ma_method=0;
//    int per;
    sum=0;    
    if (p<intperiod2) p=intperiod2;
    per=intperiod2;
applied_price=5; //PRICE_TYPICAL
timeframe=intcurtf;

    for (i=1;i<=per-1;i++) {
        sum=sum+iVolume(0,timeframe,p);
        p--;
                           }
    while (p>=0) {
        sum=sum+iVolume(0,timeframe,p);
        
	buffersma2[p]=sum/per;
        sum=sum-iVolume(0,timeframe,p+per-1);
        p--;
                 }

p=intperiod;
    for (i=1;i<=per-1;i++) {
       p--;
                           }
    while (p>=0) {
buffersmarelative[p]=buffersma1[p]/buffersma2[p];
        p--;
                 }

// SMA3      
p=intperiod;
intperiod2=50;
ma_shift=0;
ma_method=0;
//    int per;
    sum=0;    
    if (p<intperiod2) p=intperiod2;
    per=intperiod2;
applied_price=5; //PRICE_TYPICAL
timeframe=intcurtf;

   for (i=1;i<=per-1;i++) {
        sum=sum+((iHigh(0,0,p)+iLow(0,0,p)+iClose(0,0,p))/3);
        p--;
                           }
    while (p>=0) {
        sum=sum+((iHigh(0,0,p)+iLow(0,0,p)+iClose(0,0,p))/3);
        //if (p==shift+ma_shift) { return sum/per; break; }
	buffersma3[p]=sum/per;
	dvi[p]=buffersmarelative[p]-buffersma3[p];
        sum=sum-((iHigh(0,0,p+per-1)+iLow(0,0,p+per-1)+iClose(0,0,p+per-1))/3);
        p--;
                 }

      // SMA1b      
p=intperiod;
 intperiod2=5;
 ma_shift=0;
 ma_method=0;
// int per;
    sum=0;    
    if (p<intperiod2) p=intperiod2;
    per=intperiod2;
 applied_price=5; //PRICE_TYPICAL
 timeframe=intcurtf;

    for (i=1;i<=per-1;i++) {
        sum=sum+dvi[p]*iVolume(0,timeframe,p);
        p--;
                           }
    while (p>=0) {
        sum=sum+dvi[p]*iVolume(0,timeframe,p);
        //if (p==shift+ma_shift) { return sum/per; break; }
	buffersma1b[p]=sum/per;
        sum=sum-dvi[p+per-1]*iVolume(0,timeframe,p+per-1);
        p--;
                 }

 // SMA2b      
p=intperiod;
intperiod2=5;
ma_shift=0;
ma_method=0;
//    int per;
    sum=0;    
    if (p<intperiod2) p=intperiod2;
    per=intperiod2;
applied_price=5; //PRICE_TYPICAL
timeframe=intcurtf;

    for (i=1;i<=per-1;i++) {
        sum=sum+iVolume(0,timeframe,p);
        p--;
                           }
    while (p>=0) {
        sum=sum+iVolume(0,timeframe,p);
        //if (p==shift+ma_shift) { return sum/per; break; }
	buffersma2b[p]=sum/per;
        sum=sum-iVolume(0,timeframe,p+per-1);
        p--;
                 }

p=intperiod;
    for (i=1;i<=per-1;i++) {
       p--;
                           }
    while (p>=0) {
if (buffersma2b[p]==0) { Directional_Volume_Indexbuffer[p]=0; }
else { Directional_Volume_Indexbuffer[p]= buffersma1b[p]/buffersma2b[p]; }
        p--;
                 }
   //----
   return(0);
}
//+------------------------------------------------------------------+
