//+------------------------------------------------------------------+
//|                                                   valuechart.mq4 |
//|                                    Copyright  2008, Julien MOOG |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//===========
//VALUE_CHART
//===========
//d'aprs Dynamic Trading Indicators
//Winning with Value Chart and Price Action Profile
//de Mark W. Helweg et David C. Stendahl
//smallcaps90 le 18 mai 2008
//Transcod de GrapheAT Pro par Julien MOOG 
#property copyright "Copyright  2008, Julien MOOG"
#property link      "julien.moog@laposte.net"

#property indicator_separate_window
//Limites des surachats et des surventes
#property  indicator_level1  8
#property  indicator_level2  4
#property  indicator_level3  -4
#property  indicator_level4  -8
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 Magenta
double vo[],vh[],vb[],vc[];
int p1=5;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   SetIndexBuffer(0, vo);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 1);    
   SetIndexDrawBegin(0, p1);
   SetIndexBuffer(1, vh);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 1);    
   SetIndexDrawBegin(1, p1);
   SetIndexBuffer(2, vb);
   SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, 1);    
   SetIndexDrawBegin(2, p1);
   SetIndexBuffer(3, vc);
   SetIndexStyle(3, DRAW_LINE, STYLE_SOLID, 1);    
   SetIndexDrawBegin(3, p1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {   
   int    counted_bars=IndicatorCounted(),i;   
   double m1,dvu;
   
   if(Bars<=p1) return(0);
//---- initial zero
   if(counted_bars<1)
      {
      for(i=1;i<=p1;i++) 
         {
         vo[Bars-i]=0.0;   
         vh[Bars-i]=0.0;   
         vb[Bars-i]=0.0;   
         vc[Bars-i]=0.0;   
         }
      }
//----
   i=Bars-p1-1;
   if(counted_bars>=p1) i=Bars-counted_bars-1;
   while(i>=0)
      {
      //Ligne moyenne sur P1 (=5) jours
      m1=0.5*(iCustom(0,0,"ATR_Channels",5,i)+iCustom(0,0,"ATR_Channels",6,i));
      m1=m1+0.5*(iCustom(0,0,"ATR_Channels",5,i+1)+iCustom(0,0,"ATR_Channels",6,i+1));
      m1=m1+0.5*(iCustom(0,0,"ATR_Channels",5,i+2)+iCustom(0,0,"ATR_Channels",6,i+2));
      m1=m1+0.5*(iCustom(0,0,"ATR_Channels",5,i+3)+iCustom(0,0,"ATR_Channels",6,i+3));
      m1=m1+0.5*(iCustom(0,0,"ATR_Channels",5,i+4)+iCustom(0,0,"ATR_Channels",6,i+4));
      m1=m1/5; 
      //Dynamic Volatility Units     
      dvu=iCustom(0,0,"ATR_Channels",5,i)-iCustom(0,0,"ATR_Channels",6,i);
      dvu=dvu+(iCustom(0,0,"ATR_Channels",5,i+1)-iCustom(0,0,"ATR_Channels",6,i+1));
      dvu=dvu+(iCustom(0,0,"ATR_Channels",5,i+2)-iCustom(0,0,"ATR_Channels",6,i+2));
      dvu=dvu+(iCustom(0,0,"ATR_Channels",5,i+3)-iCustom(0,0,"ATR_Channels",6,i+3));
      dvu=dvu+(iCustom(0,0,"ATR_Channels",5,i+4)-iCustom(0,0,"ATR_Channels",6,i+4));
      dvu=dvu/5;
      dvu=dvu*0.2;
      //Valeurs relatives des ouvertures, des hautes, 
      //des basses et des clotures
      vo[i]=Open[i]-m1;      
      vh[i]=iCustom(0,0,"ATR_Channels",5,i)-m1;
      vb[i]=iCustom(0,0,"ATR_Channels",6,i)-m1;
      vc[i]=Close[i]-m1;
      //Correction par les DVU
      if (dvu!=0)
         {
         vo[i]=vo[i]/dvu;
         vh[i]=vh[i]/dvu;
         vb[i]=vb[i]/dvu;
         vc[i]=vc[i]/dvu;
         }
      else
         {
         vo[i]=0;
         vh[i]=0;
         vb[i]=0;
         vc[i]=0;        
         }  
      //Autre adaptation possible avec des points
      /* 
      if (vh>l1) pth=vh;
      if (vh>l2 && vh<l1) pmh=vh;
      if (vb<l4) ptb=vb;
      if (vb<l3 && vb>l4) pmb=vb;   
      */ 
      i--;        
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+